<template>
  <!-- DATA
  item: { name: String, type: String, editable: Boolean }
  -->
  <div>
    <b v-if="!item.editable">{{ item.name }}:</b>
    <b-form-input v-model="item.name" :state="true ? 'success':'warning'"
                  type="text" size='sm' v-else placeholder='Field name'/>
    <b-form-select v-model='item.type || defaultType' size='sm' :options="options"
                    class='ml-4' v-if="item.editable"/>
    <b v-else class="ml-4">{{ item.type }}</b>
    <b-button variant="danger ml-4" @click='deleteField("Article", item.name)'
              size='sm' v-if="item.editable">X
    </b-button>
  </div>
</template>

<script>
import gql from 'graphql-tag';

import { schemaTypes } from '@/data/parse';


export default {
  name: "SchemaTypeInputs",

  data() {
    return {
      defaultType: 'String'
    }
  },

  props: ['item'],

  methods: {
    deleteField(schema, name) {
      this.$apollo.mutate({
        mutation: gql`mutation Del($schema: String, $name: String) {
          deleteField(schemaName: $schema, fieldName: $name)
        }`,
        variables: { schema, name },
        update: (store, { data: deleteField }) => {
          this.$parent.$apollo.queries.schemaTypes.refetch();
        }
      })
    },
  },

  computed: {
    options() {
      return schemaTypes.map((val) => {
        return { value: val.type, text: val.type }
      })
    },
  }
}
</script>
